🛈 Note: This is pre-release documentation for the upcoming tracing 0.2.0 ecosystem.

For the release documentation, please see docs.rs, instead.

Crate tracing_error[][src]

Expand description

Utilities for enriching error handling with tracing diagnostic information.

Overview

tracing is a framework for instrumenting Rust programs to collect scoped, structured, and async-aware diagnostics. This crate provides integrations between tracing instrumentation and Rust error handling. It enables enriching error types with diagnostic information from tracing span contexts, formatting those contexts when errors are displayed, and automatically generate tracing events when errors occur.

The crate provides the following:

Note: This crate is currently experimental.

Compiler support: requires rustc 1.42+

Feature Flags

Usage

tracing-error provides the SpanTrace type, which captures the current tracing span context when it is constructed and allows it to be displayed at a later time.

For example:

use std::{fmt, error::Error};
use tracing_error::SpanTrace;

#[derive(Debug)]
pub struct MyError {
    context: SpanTrace,
    // ...
}

impl fmt::Display for MyError {
    fn fmt(&self, f: &mut fmt::Formatter<'_>) -> fmt::Result {
        // ... format other parts of the error ...

        self.context.fmt(f)?;

        // ... format other error context information, cause chain, etc ...
    }
}

impl Error for MyError {}

impl MyError {
    pub fn new() -> Self {
        Self {
            context: SpanTrace::capture(),
            // ... other error information ...
        }
    }
}

This crate also provides TracedError, for attaching a SpanTrace to an existing error. The easiest way to wrap errors in TracedError is to either use the InstrumentResult and InstrumentError traits or the From/Into traits.

use tracing_error::prelude::*;

std::fs::read_to_string("myfile.txt").in_current_span()?;

Once an error has been wrapped with with a TracedError the SpanTrace can be extracted one of 3 ways: either via TracedError’s Display/Debug implementations, or via the ExtractSpanTrace trait.

For example, here is how one might print the errors but specialize the printing when the error is a placeholder for a wrapping SpanTrace:

use std::error::Error;
use tracing_error::ExtractSpanTrace as _;

fn print_extracted_spantraces(error: &(dyn Error + 'static)) {
    let mut error = Some(error);
    let mut ind = 0;

    eprintln!("Error:");

    while let Some(err) = error {
        if let Some(spantrace) = err.span_trace() {
            eprintln!("found a spantrace:\n{}", spantrace);
        } else {
            eprintln!("{:>4}: {}", ind, err);
        }

        error = err.source();
        ind += 1;
    }
}

Whereas here, we can still display the content of the SpanTraces without any special casing by simply printing all errors in our error chain.

use std::error::Error;

fn print_naive_spantraces(error: &(dyn Error + 'static)) {
    let mut error = Some(error);
    let mut ind = 0;

    eprintln!("Error:");

    while let Some(err) = error {
        eprintln!("{:>4}: {}", ind, err);
        error = err.source();
        ind += 1;
    }
}

Applications that wish to use tracing-error-enabled errors should construct an ErrorSubscriber and add it to their collector in order to enable capturing SpanTraces. For example:

use tracing_error::ErrorSubscriber;
use tracing_subscriber::prelude::*;

fn main() {
    let subscriber = tracing_subscriber::Registry::default()
        // any number of other collector subscribers may be added before or
        // after the `ErrorSubscriber`...
        .with(ErrorSubscriber::default());

    // set the subscriber as the default for the application
    tracing::collect::set_global_default(subscriber);
}

Supported Rust Versions

Tracing is built against the latest stable release. The minimum supported version is 1.42. The current Tracing version is not guaranteed to build on Rust versions earlier than the minimum supported version.

Tracing follows the same compiler support policies as the rest of the Tokio project. The current stable Rust compiler and the three most recent minor versions before it will always be supported. For example, if the current stable compiler version is 1.45, the minimum supported version will not be increased past 1.42, three minor versions prior. Increasing the minimum supported compiler version is not considered a semver breaking change as long as doing so complies with this policy.

Modules

preludetraced-error

The tracing-error prelude.

Structs

A subscriber that enables capturing SpanTraces.

A captured trace of tracing spans.

The current status of a SpanTrace, indicating whether it was captured or whether it is empty for some other reason.

TracedErrortraced-error

A wrapper type for Errors that bundles a SpanTrace with an inner Error type.

Traits

ExtractSpanTracetraced-error

A trait for extracting SpanTraces created by in_current_span() from dyn Error trait objects

InstrumentErrortraced-error

Extension trait for instrumenting errors with SpanTraces

InstrumentResulttraced-error

Extension trait for instrumenting errors in Results with SpanTraces